/**************---< TECHNO ROAD.inc >---**************/
/*                                                   */
/*   File        :coron_sound.c                      */
/*   Version     :v3.0.0                             */
/*   Date        :2014/05/09                         */
/*   Author      :                                   */
/*   Description :Speaker output Library Source      */
/*                                                   */
/*    Copyright(C) TECHNO ROAD Inc.                  */
/*                 http://techno-road.com/           */
/*****************************************************/
#include "coron_conf.h"
#ifdef _CORON_SOUND
/* Includes ------------------------------------------------------------------*/
#include "stm32f10x_lib.h"
#include "coron_lib.h"

/* Global variables ----------------------------------------------------------*/
vu8 	sound_flag=0;				//ĐtO
vu8 	sound_buf[2][512];			//f[^obt@
vu16 sound_buf0_count=0;			//f[^obt@buf[0]oCgJEg
vu16 sound_buf1_count=0;			//f[^obt@buf[1]oCgJEg
vu8 	read_flag=0;				//obt@i[tO

vu32 spk_sct = 0;					//WAVt@C̃ZN^ԍ
vu32 spk_sec_num = 0;				//WAVt@Cf[^ZN^|1
vu32 spk_last_byte_num = 0;			//Ō̃ZN^̃oCg|1
vu32 sct_count = 1;
vu8 _sound_flag = 0;

//==============================================================================
// Xs[Jo͏
//==============================================================================
void SPK_init(void){
	GPIO_InitTypeDef 		GPIO_InitStructure;
	TIM_TimeBaseInitTypeDef TIM_TimeBaseStructure;
	DAC_InitTypeDef   		DAC_InitStructure;
	NVIC_InitTypeDef 		NVIC_InitStructure;

	/* Default reset */
	TIM_DeInit(TIM5);

	//Speaker init
	GPIO_StructInit(&GPIO_InitStructure);
	GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_4;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AIN;
	GPIO_Init(GPIOA, &GPIO_InitStructure);

	/* Enable the TIM5 Interrupt */
	NVIC_StructInit(&NVIC_InitStructure);
	NVIC_InitStructure.NVIC_IRQChannel = TIM5_IRQn;
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 8;
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
	NVIC_Init(&NVIC_InitStructure);

	/* TIM5 clock enable */
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM5, ENABLE);
	/* DAC Periph clock enable */
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_DAC, ENABLE);

	/* TIM5 configuration */
	TIM_TimeBaseStructInit(&TIM_TimeBaseStructure);
	TIM_TimeBaseStructure.TIM_Period = 653;
	TIM_TimeBaseStructure.TIM_Prescaler = 0x0004;
	TIM_TimeBaseStructure.TIM_ClockDivision = 0;
	TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up;
	TIM_TimeBaseStructure.TIM_RepetitionCounter = 0x0000;
	TIM_TimeBaseInit(TIM5, &TIM_TimeBaseStructure);
	/* Immediate load of TIM5 Prescaler value */
	TIM_PrescalerConfig(TIM5, 0x0004, TIM_PSCReloadMode_Immediate);
	/* Clear TIM5 update pending flag */
	TIM_ClearFlag(TIM5, TIM_FLAG_Update);
	/* Enable TIM5 Update interrupt */
	TIM_ITConfig(TIM5, TIM_IT_Update, ENABLE);
	/* TIM5 disable counter */
	TIM_Cmd(TIM5, DISABLE);

	/* TIM8 clock enable */
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_TIM8, ENABLE);
	/* Default reset */
	TIM_DeInit(TIM8);
	/* Enable the TIM8 Interrupt */
	NVIC_StructInit(&NVIC_InitStructure);
	NVIC_InitStructure.NVIC_IRQChannel = TIM8_UP_IRQn;
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 9;
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
	NVIC_Init(&NVIC_InitStructure);
	/* TIM8 configuration */
	TIM_TimeBaseStructInit(&TIM_TimeBaseStructure);
	TIM_TimeBaseStructure.TIM_Period = 653;
	TIM_TimeBaseStructure.TIM_Prescaler = 200-1;
	TIM_TimeBaseStructure.TIM_ClockDivision = 0;
	TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up;
	TIM_TimeBaseStructure.TIM_RepetitionCounter = 0x0000;
	TIM_TimeBaseInit(TIM8, &TIM_TimeBaseStructure);
	/* Immediate load of TIM8 Prescaler value */
	TIM_PrescalerConfig(TIM8, 200-1, TIM_PSCReloadMode_Immediate);
	/* Clear TIM8 update pending flag */
	TIM_ClearFlag(TIM8, TIM_FLAG_Update);
	/* Enable TIM8 Update interrupt */
	TIM_ITConfig(TIM8, TIM_IT_Update, ENABLE);
	/* TIM8 disable counter */
	TIM_Cmd(TIM8, DISABLE);

	/* DAC channel1 Configuration */
	DAC_StructInit(&DAC_InitStructure);
	DAC_InitStructure.DAC_Trigger = DAC_Trigger_Software;
	DAC_InitStructure.DAC_WaveGeneration = DAC_WaveGeneration_None;
	DAC_InitStructure.DAC_LFSRUnmask_TriangleAmplitude = DAC_LFSRUnmask_Bit0;
	DAC_InitStructure.DAC_OutputBuffer = DAC_OutputBuffer_Enable;
	DAC_Init(DAC_Channel_1, &DAC_InitStructure);

	/* Ensable DAC Channel1 */
	DAC_Cmd(DAC_Channel_1, ENABLE);
	DAC_SetChannel1Data(DAC_Align_8b_R,0x80);
	DAC_SoftwareTriggerCmd(DAC_Channel_1, ENABLE);
}

//==============================================================================
// Xs[J[AiOo(TIM5荞)
//==============================================================================
void TIM5_SOUND_IRQ(void){
	//22[kHz]
	TIM_ClearFlag(TIM5, TIM_FLAG_Update);//TIM5荞݃tONA

	if(sound_flag == 0){
		return;
	}

RESTART:
	//f[^buf0buf1Ō݂ɍĐ(SDJ[h̓ǂݍ݂ƉĐ𓯎ɂ)
	if(sound_flag==1){//buf0Đ
    	if(sound_buf0_count==512){	//buf0ĐI
   			if(read_flag==1){		//	buf1f[^ǂݍ݊mF
   				sound_buf0_count=0;
   	   			sound_flag=2;		//	buf1ĐJn
   	   			goto RESTART;
   			}
    	}
    	else{
    		//DAC1 o͓dl(8bitEl)Zbg
   			DAC_SetChannel1Data(DAC_Align_8b_R, sound_buf[0][sound_buf0_count]);
    		//DAC1 o̓gKZbg
    		DAC_SoftwareTriggerCmd(DAC_Channel_1, ENABLE);
    		sound_buf0_count++;
    	}
   	}
    else if(sound_flag==2){//buf1Đ
    	if(sound_buf1_count==512){	//buf1ĐI
   			if(read_flag==1){		//	buf0f[^ǂݍ݊mF
   	    		sound_buf1_count=0;
   	    		sound_flag=1;		//	buf0ĐJn
   	   			goto RESTART;
   			}
    	}
    	else{
    		//DAC1 o͓dl(8bitEl)Zbg
    		DAC_SetChannel1Data(DAC_Align_8b_R, sound_buf[1][sound_buf1_count]);
    		//DAC1 o̓gKZbg
    		DAC_SoftwareTriggerCmd(DAC_Channel_1, ENABLE);
    		sound_buf1_count++;
   		}
   	}
    else if(sound_flag==0){//f[^Đ~
    	sound_buf0_count=0;
    	sound_buf1_count=0;
    }
}

//==============================================================================
// ZN^ǂݍ(TIM8荞)
//==============================================================================
void TIM8_READ_SECTOR_IRQ(void){
	//550Hz
	TIM_ClearFlag(TIM8, TIM_FLAG_Update);//TIM8荞݃tONA

	vu32 i;
	if(sct_count < spk_sec_num){
		if(read_flag == 0){
			//Qڈȍ~̃ZN^ǂݍ
			SD_read(512*(sct_count + spk_sct));
			_sound_flag = sound_flag;
			if(sound_flag==2){
				for(i=0;i<512;i++){sound_buf[0][i]=buf512[i];}
				read_flag=1;
			}
			else if(sound_flag==1){
				for(i=0;i<512;i++){sound_buf[1][i]=buf512[i];}
				read_flag=1;
			}
		}
		else{
			if(sound_flag != _sound_flag){
				sct_count++;
				read_flag=0;
			}
		}
	}
	else if(sct_count == spk_sec_num){
		if(read_flag == 0){
			//Ō̃ZN^ǂݍ(f[^΂)
			SD_read(512*(spk_sct+spk_sec_num));
			for(i=spk_last_byte_num;i<512;i++){
				buf512[i]=0x80;
			}

			_sound_flag = sound_flag;
			if(sound_flag==2){
				for(i=0;i<512;i++){sound_buf[0][i]=buf512[i];}
				read_flag=1;
			}
			else if(sound_flag==1){
				for(i=0;i<512;i++){sound_buf[1][i]=buf512[i];}
				read_flag=1;
			}
		}
		else{
			if(sound_flag != _sound_flag){
				sound_flag=0;
				sct_count++;
				TIM_Cmd(TIM5, DISABLE);
				TIM_Cmd(TIM8, DISABLE);
			}
		}
	}
	else{
		return;
	}
}

//==============================================================================
// ZN^Zbg
//==============================================================================
void SPK_set_sector_info(u32 _sct, u32 _sec_num, u32 _last_byte_num){
	sct_count = 1;
	spk_sct = _sct;
	spk_sec_num = _sec_num;
	spk_last_byte_num = _last_byte_num;
}

#endif
